# Remove duplicate libraries, generalized from PCLConfig.cmake.in
macro(remove_duplicate_libraries _unfiltered_libraries _final_filtered_libraries)
  set(_filtered_libraries)
  set(_debug_libraries)
  set(_optimized_libraries)
  set(_other_libraries)
  set(_waiting_for_debug 0)
  set(_waiting_for_optimized 0)
  set(_library_position -1)
  foreach(library ${${_unfiltered_libraries}})
    if("${library}" STREQUAL "debug")
      set(_waiting_for_debug 1)
    elseif("${library}" STREQUAL "optimized")
      set(_waiting_for_optimized 1)
    elseif(_waiting_for_debug)
      list(FIND _debug_libraries "${library}" library_position)
      if(library_position EQUAL -1)
        list(APPEND ${_filtered_libraries} debug ${library})
        list(APPEND _debug_libraries ${library})
      endif()
      set(_waiting_for_debug 0)
    elseif(_waiting_for_optimized)
      list(FIND _optimized_libraries "${library}" library_position)
      if(library_position EQUAL -1)
        list(APPEND ${_filtered_libraries} optimized ${library})
        list(APPEND _optimized_libraries ${library})
      endif()
      set(_waiting_for_optimized 0)
    else("${library}" STREQUAL "debug")
      list(FIND _other_libraries "${library}" library_position)
      if(library_position EQUAL -1)
        list(APPEND ${_filtered_libraries} ${library})
        list(APPEND _other_libraries ${library})
      endif()
    endif("${library}" STREQUAL "debug")
  endforeach(library)
  set(_final_filtered_libraries _filtered_libraries)
endmacro(remove_duplicate_libraries)


if (libg2o_CONFIG_INCLUDED)
  return()
endif()
set(libg2o_CONFIG_INCLUDED TRUE)

if (NOT "X" STREQUAL "X")
  set(libg2o_INCLUDE_DIRS /opt/ros/fuerte/include) #TODO FIX this.
endif()

foreach(lib g2o_cli;g2o_core;g2o_csparse_extension;g2o_ext_freeglut_minimal;g2o_incremental;g2o_interactive;g2o_interface;g2o_opengl_helper;g2o_parser;g2o_simulator;g2o_solver_cholmod;g2o_solver_csparse;g2o_solver_dense;g2o_solver_pcg;g2o_solver_slam2d_linear;g2o_solver_structure_only;g2o_stuff;g2o_types_data;g2o_types_icp;g2o_types_sba;g2o_types_sclam2d;g2o_types_sim3;g2o_types_slam2d;g2o_types_slam3d)
  set(onelib "${lib}-NOTFOUND")
  find_library(onelib ${lib}
    PATHS /opt/ros/fuerte/lib
    NO_DEFAULT_PATH
    )
  if(NOT onelib)
    message(FATAL_ERROR "Library '${lib}' in package libg2o is not installed properly")
  endif()
  list(APPEND libg2o_LIBRARIES ${onelib})
endforeach()

foreach(dep )
  if(NOT ${dep}_FOUND)
    find_package(${dep})
  endif()
  list(APPEND libg2o_INCLUDE_DIRS ${${dep}_INCLUDE_DIRS})
  list(APPEND libg2o_LIBRARIES ${${dep}_LIBRARIES})
endforeach()

if (libg2o_INCLUDE_DIRS)
  list(REMOVE_DUPLICATES libg2o_INCLUDE_DIRS)
endif()
if(libg2o_LIBRARIES)
  remove_duplicate_libraries(libg2o_LIBRARIES libg2o_LIBRARIES)
endif()

foreach(extra )
  include(/opt/ros/fuerte/share/libg2o/cmake/${extra})
endforeach()
